/*
** FamiTracker - NES/Famicom sound tracker
** Copyright (C) 2005-2010  Jonathan Liss
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful, 
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
** Library General Public License for more details.  To obtain a 
** copy of the GNU Library General Public License, write to the Free 
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
** Any permitted reproduction of these routines, in whole or in part,
** must bear this legend.
*/

#include "FtmDocument.hpp"
#include "TrackerChannel.h"

CTrackerChannel::CTrackerChannel() :
	m_iColumnCount(0),
	m_bNewNote(false),
	m_iPitch(0)
{
}

CTrackerChannel::~CTrackerChannel(void)
{
}

const int CTrackerChannel::GetColumnCount() const
{
	return m_iColumnCount;
}

void CTrackerChannel::SetColumnCount(int Count)
{
	m_iColumnCount = Count;
}

void CTrackerChannel::SetNote(stChanNote Note)
{
	m_Note = Note;
	m_bNewNote = true;
}

stChanNote CTrackerChannel::GetNote()
{
	stChanNote Note;
	m_bNewNote = false;
	Note = m_Note;
	return Note;
}

bool CTrackerChannel::NewNoteData()
{
	bool bNewNote;
	bNewNote = m_bNewNote;
	return bNewNote;
}

void CTrackerChannel::Reset()
{
	m_bNewNote = false;
}

void CTrackerChannel::SetVolumeMeter(int Value)
{
	m_iVolumeMeter = Value;
}

int CTrackerChannel::GetVolumeMeter() const
{
	return m_iVolumeMeter;
}

void CTrackerChannel::SetPitch(int Pitch)
{
	m_iPitch = Pitch;
}

int CTrackerChannel::GetPitch() const
{
	return m_iPitch;
}
/*
int CTrackerChannel::GetEffect(int Letter) const
{
	if (m_iChip == SNDCHIP_FDS)
	{
	}

	return 
}
*/
